package com.idtech.worldpaydemo;

import static android.app.PendingIntent.getActivity;
import static android.os.Build.VERSION.SDK_INT;

import android.Manifest;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Build;
import android.os.Environment;
import android.provider.Settings;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Set;
import android.app.Activity;
import android.app.Dialog;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.idtechproducts.device.IDTEMVData;
import com.idtechproducts.device.IDTMSRData;
import com.idtechproducts.device.OnReceiverListener;
import com.idtechproducts.device.OnReceiverListenerPIN;
import com.idtechproducts.device.OnReceiverListenerPINRequest;
import com.idtechproducts.device.StructConfigParameters;
import com.idtechproducts.device.WorldpayListener;
import com.idtechproducts.device.*;
import com.idtechproducts.device.ReaderInfo.CAPTURE_ENCODE_TYPE;
import com.idtechproducts.device.ReaderInfo.CAPTURE_ENCRYPT_TYPE;
import com.idtechproducts.device.ReaderInfo.EVENT_MSR_Types;
import com.idtechproducts.device.audiojack.UMLog;

public class MainActivity extends AppCompatActivity implements OnReceiverListener, WorldpayListener, OnReceiverListenerPIN {

    // declaring the instance of the NEO2Reader;
    private IDT_Device device = null;
    private WorldPay wp = null;
    private TextView connectStatusTextView;
    private TextView textLog;
    private TextView lcdLog;
    private Button btnGetFirmware;
    private Button btnStartTransaction;
    private Button btnCancelTransaction;
    private Button btnCompleteTransaction;
    private Button btnSaleTransaction;
    private Button btnSalesdTransaction;
    private Handler handler = new Handler();
    private boolean isReaderConnected = false;
    private String info = "";
    private String detail = "";
    MainActivity thisActivity = null;
    private final int PID_KIOSK_IV = 0x4480;
    private final int PID_VP3600 = 0x4311;
    private final int PID_VP5300 = 0x4450;
    private final int PID_VP6300 = 0x4440;
    private final int PID_VP6800 = 0x4500;
    private final int PID_VP3310 = 0x4490;
    private final int PID_VP3320 = 0x4510;
    private final int PID_VP3350 = 0x4650;
    private final int PID_KIOSK_V = 0x4691;

    private boolean qs = true;
    private boolean qc = true;
    private String transactionID = "";
    private boolean enableLog = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        handler = new Handler();
        thisActivity = this;
        btnStartTransaction = (Button)findViewById(R.id.btn_StartTransaction);
        btnCancelTransaction = (Button)findViewById(R.id.btn_CancelTransaction);
        btnCompleteTransaction = (Button)findViewById(R.id.btn_CompleteTransaction);
        btnSaleTransaction = (Button)findViewById(R.id.btn_SaleTransaction);
        btnGetFirmware = (Button)findViewById(R.id.btn_getFirmware);
        textLog = (TextView)findViewById(R.id.textLog);
        lcdLog = (TextView)findViewById(R.id.lcdLog);
        connectStatusTextView = (TextView)findViewById(R.id.status_text);
        if(device!=null){
            device.unregisterListen();
            device.release();
            device = null;
        }
        device = new IDT_Device(thisActivity,thisActivity);

        //get permission
        if (SDK_INT >= Build.VERSION_CODES.R) {
            if (!Environment.isExternalStorageManager()) {
                Intent intent = new Intent(Settings.ACTION_MANAGE_APP_ALL_FILES_ACCESS_PERMISSION);
                Uri uri = Uri.fromParts("package", getPackageName(), null);
                intent.setData(uri);
                startActivity(intent);
            }
            if (ActivityCompat.checkSelfPermission(thisActivity, Manifest.permission.BLUETOOTH_CONNECT) == PackageManager.PERMISSION_DENIED ||
                    ActivityCompat.checkSelfPermission(thisActivity, Manifest.permission.BLUETOOTH_SCAN) == PackageManager.PERMISSION_DENIED ||
                    ActivityCompat.checkSelfPermission(thisActivity, Manifest.permission.RECORD_AUDIO) == PackageManager.PERMISSION_DENIED ||
                    ActivityCompat.checkSelfPermission(thisActivity, Manifest.permission.ACCESS_FINE_LOCATION) == PackageManager.PERMISSION_DENIED ||
                    ActivityCompat.checkSelfPermission(thisActivity, Manifest.permission.ACCESS_COARSE_LOCATION) == PackageManager.PERMISSION_DENIED) {
                // Requesting the permission
                ActivityCompat.requestPermissions(thisActivity, new String[]{Manifest.permission.ACCESS_FINE_LOCATION, Manifest.permission.ACCESS_COARSE_LOCATION, Manifest.permission.BLUETOOTH_CONNECT, Manifest.permission.BLUETOOTH_SCAN, Manifest.permission.RECORD_AUDIO}, 2);
            }
        } else {
            if (ActivityCompat.checkSelfPermission(thisActivity, Manifest.permission.WRITE_EXTERNAL_STORAGE) == PackageManager.PERMISSION_DENIED ||
                    ActivityCompat.checkSelfPermission(thisActivity, Manifest.permission.READ_EXTERNAL_STORAGE) == PackageManager.PERMISSION_DENIED ||
                    ActivityCompat.checkSelfPermission(thisActivity, Manifest.permission.RECORD_AUDIO) == PackageManager.PERMISSION_DENIED ||
                    ActivityCompat.checkSelfPermission(thisActivity, Manifest.permission.ACCESS_FINE_LOCATION) == PackageManager.PERMISSION_DENIED ||
                    ActivityCompat.checkSelfPermission(thisActivity, Manifest.permission.ACCESS_COARSE_LOCATION) == PackageManager.PERMISSION_DENIED) {
                // Requesting the permission
                ActivityCompat.requestPermissions(thisActivity, new String[]{Manifest.permission.ACCESS_FINE_LOCATION, Manifest.permission.ACCESS_COARSE_LOCATION, Manifest.permission.RECORD_AUDIO, Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE}, 1);
            }
        }

        //  boolean connected = device.device_setDeviceType(ReaderInfo.DEVICE_TYPE.DEVICE_VP3300_AJ_USB);
        /*
         boolean connected = device.device_setDeviceType(ReaderInfo.DEVICE_TYPE.DEVICE_VP3300_BT);
         device.device_disconnectBLE();
        int rc = device.device_enableBLESearch(device.device_getDeviceType(), "IDTECH-VP3300-68947", 10000) ;
        if (rc != 0){
            if (rc == 1 ) info += "Invalid DEVICE_TYPE";
            if (rc == 2 ) info +=  "Bluetooth LE is not supported on this device";
            if (rc == 3 ) info += "Bluetooth LE is not available";
            if (rc == 4 ) info +=  "Bluetooth LE is not enabled";
            if (rc == 5 ) info +=  "Device not paired. Please pair first";
            detail = "";
            handler.post(doUpdateStatus);
        }
        */



//        boolean connected = device.device_setDeviceType(ReaderInfo.DEVICE_TYPE.DEVICE_VP3300_USB);

//         if (!device.device_isConnected()) {
//             device.device_setDeviceType(ReaderInfo.DEVICE_TYPE.DEVICE_NEO2_USB, PID_KIOSK_V);
//             if (device.device_isConnected())
//                device.device_setNEOGen(3);
//         }

        // boolean connected = device.device_setDeviceType(ReaderInfo.DEVICE_TYPE.DEVICE_AUGUSTA, false, true, false);  //Augusta S version
        // boolean connected = device.device_setDeviceType(ReaderInfo.DEVICE_TYPE.DEVICE_NEO2_USB, PID_VP6300);
        // boolean connected = device.device_setDeviceType(ReaderInfo.DEVICE_TYPE.DEVICE_MINISMART_II);

       // boolean connected = device.device_setDeviceType(ReaderInfo.DEVICE_TYPE.DEVICE_VP3300_USB);


//        if (device.device_getDeviceType() != ReaderInfo.DEVICE_TYPE.DEVICE_VP3300_BT) device.registerListen();


        btnGetFirmware.setOnClickListener(new Button.OnClickListener() {
            public void onClick(View v) {
                if (!enableLog) {
                    enableLog = true;
                    //delete logs
//                  device.log_deleteLogs();
                    //enable log
                    device.log_setVerboseLoggingEnable(true);
                    device.log_setSaveLogEnable(true);
                }
                info = "Getting Firmware\n";
                detail = "";
                handler.post(doUpdateStatus);
                StringBuilder sb = new StringBuilder();
                int ret = device.device_getFirmwareVersion(sb);
                if (ret == ErrorCode.SUCCESS) {
                    info += "Firmware Version: " + sb.toString();
                    detail = "";
                    handler.post(doUpdateStatus);
                }
                else {
                    info += "GetFirmwareVersion: Failed\n";
                    info += "Status: "+ device.device_getResponseCodeString(ret)+"";
                    detail = "";
                    handler.post(doUpdateStatus);
                }
            }
        });

        btnStartTransaction.setOnClickListener(new Button.OnClickListener(){
            public void onClick(View v) {
                if (!enableLog) {
                    enableLog = true;
                    //delete logs
//                  device.log_deleteLogs();
                    //enable log
                    device.log_setVerboseLoggingEnable(true);
                    device.log_setSaveLogEnable(true);
                }
                detail = "";
                info = "Starting WorldPay Pre-Auth Transaction\n";
                handler.post(doUpdateStatus);

                if (wp == null) wp = new WorldPay();

                WorldPay.WorldPayData data = new WorldPay.WorldPayData();
                data.accountID = "1188346";
                data.accountToken = "E1EB3EFB049DFB599F1CB454E1CFC4FD14BF90BCE74456AE9E9490D7D609B466C81A3801";
//                data.accountToken = "C8E33719BEC41A4EA07B9E09681ED1323B9074E1651209203BE4C24452E884B4DD848601";
                data.acceptorID = "364798674";
                //data.accountID = "1188347";
                //data.accountToken = "56C0FEC827F65B3F6A9168C3D9EF477A1C4AE22B36D2A08B6334AC59E789B6336A11E701";
//                data.acceptorID = "364800780";
//                data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_SALE;
                 data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_PRE_AUTH;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_COMPLETION;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_REVERSAL_FULL;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_REVERSAL_PARTIAL;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_VOID;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_RETURN;
//                 data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_QUICK_CHIP_START;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_QUICK_CHIP_FINISH;

                data.amount = "200.00";   //specify transaction Amount
                data.timeout =  30;  //Timeout for transaction
                data.isTest = true;  //if test transaction, set to TRUE.  If live transactions, set to FALSE
                data.msrOnly = false; //for EMV + MSR, set to FALSE.  If MSR swipe only, set to TRUE
                data.enableCTLS = true; //for EMV + MSR + CTLS, set to TRUE and msrOnly to FALSE.  If MSR swipe only, set to TRUE
                data.transactionID = "3830"; //required if COMPLETION.  Otherwise, leave blank
                data.referenceNumber = "112233445566"; //required value.  If blank, SDK will put in random number
                data.terminalID = "12345"; //required value.  Set a terminal identifer
                data.ticketNumber = "54321"; //required value.  If blank, SDK will put in random number
                data.duplicateCheck = false;  //set to TRUE if you want to check for duplicate transactions
                data.duplicateOverride = true;  //set to TRUE if you want to allow duplicate charges to same card

                if (device.device_getDeviceType() == ReaderInfo.DEVICE_TYPE.DEVICE_NEO2_USB) {
                    data.additionalTags = "DFEF370102";
                } else {
                    data.additionalTags = "FFEE06189F220201009F2604000000019F2B050100000000DF010101FFEE080ADFEF1A0109DFED280100DFEF370102";
                }

//                if (qc) {
//                    qc = false;
//                    data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_QUICK_CHIP_START;
//                } else {
//                    qc = true;
//                    data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_QUICK_CHIP_FINISH;
//                    data.transactionID = transactionID;
//                }

//                data.license = "24sngsailwtb-1ufv0z2ao3jb";
                data.declinePartial = false;

                wp.returnRequest = true; //set to TRUE if you would like the request packet returned with the response

                boolean requestOnly = false; // If this is TRUE, the SDK will return the read of contacting WorldPay with it. For integrations that want to control communication with WorldPay servers
                int ret = wp.executeTransaction(device,data,thisActivity,requestOnly);
                if (ret == ErrorCode.SUCCESS) {
                    if (data.transactionType == WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_SALE ||
                            data.transactionType == WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_PRE_AUTH ||
                            data.transactionType == WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_QUICK_CHIP_START) {
                        info += "Transaction Started Successfully";
                    }
                    detail = "";
                    handler.post(doUpdateStatus);
                }
                else {
                    info += "Start Transaction Failed\n";
                    info += "Status: "+ device.device_getResponseCodeString(ret)+"";
                    detail = "";
//                    inTransaction = false;
                    handler.post(doUpdateStatus);
                }

               // IDT_NEO2.emv_allowFallback(true);
                //device.emv_startTransaction(1.00, 0.00, 0, 30, null, false);
            }
        });

        btnCompleteTransaction.setOnClickListener(new Button.OnClickListener(){
            public void onClick(View v) {
//                if (inTransaction) {
//                    return;
//                }
                if (!enableLog) {
                    enableLog = true;
                    //delete logs
//                  device.log_deleteLogs();
                    //enable log
                    device.log_setVerboseLoggingEnable(true);
                    device.log_setSaveLogEnable(true);
                }
                detail = "";
                info = "Starting WorldPay Complete Transaction\n";
                handler.post(doUpdateStatus);

                if (wp == null) wp = new WorldPay();

                WorldPay.WorldPayData data = new WorldPay.WorldPayData();
                data.accountID = "1188346";
                data.accountToken = "E1EB3EFB049DFB599F1CB454E1CFC4FD14BF90BCE74456AE9E9490D7D609B466C81A3801";
//                data.accountToken = "C8E33719BEC41A4EA07B9E09681ED1323B9074E1651209203BE4C24452E884B4DD848601";
                data.acceptorID = "364798674";
                //data.accountID = "1188347";
                //data.accountToken = "56C0FEC827F65B3F6A9168C3D9EF477A1C4AE22B36D2A08B6334AC59E789B6336A11E701";
//                data.acceptorID = "364800780";
//                data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_SALE;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_PRE_AUTH;
                 data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_COMPLETION;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_REVERSAL_FULL;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_REVERSAL_PARTIAL;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_VOID;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_RETURN;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_QUICK_CHIP_START;
//                 data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_QUICK_CHIP_FINISH;

                data.amount = "60.00";   //specify transaction Amount
                data.timeout =  30;  //Timeout for transaction
                data.isTest = true;  //if test transaction, set to TRUE.  If live transactions, set to FALSE
                data.msrOnly = false; //for EMV + MSR, set to FALSE.  If MSR swipe only, set to TRUE
                data.enableCTLS = true; //for EMV + MSR + CTLS, set to TRUE and msrOnly to FALSE.  If MSR swipe only, set to TRUE
                data.transactionID = "3830"; //required if COMPLETION.  Otherwise, leave blank
                data.referenceNumber = "112233445566"; //required value.  If blank, SDK will put in random number
                data.terminalID = "12345"; //required value.  Set a terminal identifer
                data.ticketNumber = "54321"; //required value.  If blank, SDK will put in random number
                data.duplicateCheck = false;  //set to TRUE if you want to check for duplicate transactions
                data.duplicateOverride = true;  //set to TRUE if you want to allow duplicate charges to same card

//                if (qc) {
//                    qc = false;
//                    data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_QUICK_CHIP_START;
//                } else {
//                    qc = true;
//                    data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_QUICK_CHIP_FINISH;
                    data.transactionID = transactionID;
//                }

//                data.license = "24sngsailwtb-1ufv0z2ao3jb";
                data.declinePartial = false;

                wp.returnRequest = true; //set to TRUE if you would like the request packet returned with the response

                boolean requestOnly = false; // If this is TRUE, the SDK will return the request packet instead of contacting WorldPay with it. For integrations that want to control communication with WorldPay servers

                int ret = wp.executeTransaction(device,data,thisActivity,requestOnly);
                if (ret == ErrorCode.SUCCESS) {
                    if (data.transactionType == WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_SALE ||
                            data.transactionType == WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_PRE_AUTH ||
                            data.transactionType == WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_QUICK_CHIP_START) {
                        info += "Transaction Started Successfully";
                    }
                    detail = "";
                    handler.post(doUpdateStatus);
                }
                else {
                    info += "Start Transaction Failed\n";
                    info += "Status: "+ device.device_getResponseCodeString(ret)+"";
                    detail = "";
                    handler.post(doUpdateStatus);
                }

                // IDT_NEO2.emv_allowFallback(true);
                //device.emv_startTransaction(1.00, 0.00, 0, 30, null, false);
            }
        });

        btnSaleTransaction.setOnClickListener(new Button.OnClickListener(){
            public void onClick(View v) {
//                if (inTransaction) {
//                    return;
//                } else {
//                    inTransaction = true;
//                }
                if (!enableLog) {
                    enableLog = true;
                    //delete logs
//                  device.log_deleteLogs();
                    //enable log
                    device.log_setVerboseLoggingEnable(true);
                    device.log_setSaveLogEnable(true);
                }
                detail = "";
                info = "Starting WorldPay Sale Transaction\n";
                handler.post(doUpdateStatus);

                if (wp == null) wp = new WorldPay();

                WorldPay.WorldPayData data = new WorldPay.WorldPayData();
                data.accountID = "1188346";
                data.accountToken = "E1EB3EFB049DFB599F1CB454E1CFC4FD14BF90BCE74456AE9E9490D7D609B466C81A3801";
//                data.accountToken = "C8E33719BEC41A4EA07B9E09681ED1323B9074E1651209203BE4C24452E884B4DD848601";
                data.acceptorID = "364798674";
                //data.accountID = "1188347";
                //data.accountToken = "56C0FEC827F65B3F6A9168C3D9EF477A1C4AE22B36D2A08B6334AC59E789B6336A11E701";
//                data.acceptorID = "364800780";
                data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_SALE;
//                data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_PRE_AUTH;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_COMPLETION;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_REVERSAL_FULL;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_REVERSAL_PARTIAL;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_VOID;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_RETURN;
//                 data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_QUICK_CHIP_START;
                // data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_QUICK_CHIP_FINISH;

                data.amount = "200.00";   //specify transaction Amount
                data.timeout =  30;  //Timeout for transaction
                data.isTest = true;  //if test transaction, set to TRUE.  If live transactions, set to FALSE
                data.msrOnly = false; //for EMV + MSR, set to FALSE.  If MSR swipe only, set to TRUE
                data.enableCTLS = true; //for EMV + MSR + CTLS, set to TRUE and msrOnly to FALSE.  If MSR swipe only, set to TRUE
                data.transactionID = "3830"; //required if COMPLETION.  Otherwise, leave blank
                data.referenceNumber = "112233445566"; //required value.  If blank, SDK will put in random number
                data.terminalID = "12345"; //required value.  Set a terminal identifer
                data.ticketNumber = "54321"; //required value.  If blank, SDK will put in random number
                data.duplicateCheck = false;  //set to TRUE if you want to check for duplicate transactions
                data.duplicateOverride = true;  //set to TRUE if you want to allow duplicate charges to same card

                if (device.device_getDeviceType() == ReaderInfo.DEVICE_TYPE.DEVICE_NEO2_USB) {
                    data.additionalTags = "DFEF370102";
                } else {
                    data.additionalTags = "FFEE06189F220201009F2604000000019F2B050100000000DF010101FFEE080ADFEF1A0109DFED280100DFEF370102";
                }

//                if (qc) {
//                    qc = false;
//                    data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_QUICK_CHIP_START;
//                } else {
//                    qc = true;
//                    data.transactionType =  WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_QUICK_CHIP_FINISH;
//                    data.transactionID = transactionID;
//                }

//                data.license = "24sngsailwtb-1ufv0z2ao3jb";
                data.declinePartial = false;

                wp.returnRequest = true; //set to TRUE if you would like the request packet returned with the response

                boolean requestOnly = false; // If this is TRUE, the SDK will return the read of contacting WorldPay with it. For integrations that want to control communication with WorldPay servers
                int ret = wp.executeTransaction(device,data,thisActivity,requestOnly);
                if (ret == ErrorCode.SUCCESS) {
                    if (data.transactionType == WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_SALE ||
                            data.transactionType == WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_PRE_AUTH ||
                            data.transactionType == WorldPay.TRANSACTION_TYPE.TRANSACTION_TYPE_QUICK_CHIP_START) {
                        info += "Transaction Started Successfully";
                    }
                    detail = "";
                    handler.post(doUpdateStatus);
                }
                else {
                    info += "Start Transaction Failed\n";
                    info += "Status: "+ device.device_getResponseCodeString(ret)+"";
                    detail = "";
//                    inTransaction = false;
                    handler.post(doUpdateStatus);
                }

                // IDT_NEO2.emv_allowFallback(true);
                //device.emv_startTransaction(1.00, 0.00, 0, 30, null, false);
            }
        });

        btnCancelTransaction.setOnClickListener(new Button.OnClickListener(){
            public void onClick(View v) {
                if (!enableLog) {
                    enableLog = true;
                    //delete logs
//                  device.log_deleteLogs();
                    //enable log
                    device.log_setVerboseLoggingEnable(true);
                    device.log_setSaveLogEnable(true);
                }
                detail = "";
                info = "Canceling Worldpay Transaction\n";
//                handler.post(doUpdateStatus);
                ResDataStruct resData = new ResDataStruct();
               // device.emv_cancelEMVTransaction(resData);
                if (wp == null) wp = new WorldPay();
                int ret = wp.cancelTransaction();
                if (ret == ErrorCode.SUCCESS) {
                    info += "Transaction Cancel Successful";
                    detail = "";
//                    handler.post(doUpdateStatus);
                }
                else {
                    info += "Cancel Transaction Failed\n";
                    info += "Status: "+ device.device_getResponseCodeString(ret)+"";
                    detail = "";
//                    handler.post(doUpdateStatus);
                }
                handler.post(doUpdateStatus);
            }
        });

        openReaderSelectDialog();

    }

    void openReaderSelectDialog() {
        AlertDialog.Builder builder = new AlertDialog.Builder(thisActivity);
        builder.setTitle("Select a device:");
        builder.setCancelable(false);
        builder.setItems(R.array.reader_type, new DialogInterface.OnClickListener() {

            public void onClick(DialogInterface dialog, int which) {
                switch(which) {
                    case 0:
                        device.device_setDeviceType(ReaderInfo.DEVICE_TYPE.DEVICE_VP3300_USB);
                        break;
                    case 1:
						device.device_setDeviceType(ReaderInfo.DEVICE_TYPE.DEVICE_NEO2_USB, PID_KIOSK_V);
                        device.device_setNEOGen(3);
                        break;
                }
                if (device.device_getDeviceType() != ReaderInfo.DEVICE_TYPE.DEVICE_NEO2_BT)
                    device.registerListen();
            }
        });
        builder.create().show();
    }

    private Runnable doUpdateStatus = new Runnable()
    {
        public void run()
        {
            lcdLog.setText(info);
            textLog.setText(detail);
        }
    };

    private Runnable doUpdateLabel = new Runnable()
    {
        public void run()
        {
            if(!isReaderConnected){
                connectStatusTextView.setText("DEVICE DISCONNECTED");
            }
            else{
                connectStatusTextView.setText("DEVICE CONNECTED");
            }
        }
    };


    @Override
    public void swipeMSRData(IDTMSRData idtmsrData) {

    }

    @Override
    public void lcdDisplay(int mode, String[] lines, int timeout) {
        UMLog.i("WorldPay Demo lcdDisplay 1", "mode " + mode);
//        thisActivity.runOnUiThread(new Runnable() {
//            public void run() {
                if (mode == 0x01) //Menu Display
                {
                    //automatically select 1st application
                    device.emv_lcdControlResponse((byte)mode, (byte)0x01);
                }
                else if (mode == 0x08) //Language Menu Display
                {
                    //automatically select first language
                    device.emv_lcdControlResponse((byte)mode, (byte)0x01);
                }
                else{
                    ResDataStruct toData = new ResDataStruct();
                    info = lines[0];
                    handler.post(doUpdateStatus);
                }
//            }
//        });
    }

    @Override
    public void lcdDisplay(int i, String[] strings, int i1, byte[] bytes, byte b) {
        UMLog.i("WorldPay Demo lcdDisplay 2", "mode " + i);
    }

    @Override
    public void ctlsEvent(byte ctls_Event, byte ctlsScheme, byte ctlsEventData) {
        info = "Event Scheme "+ctls_Event+"\r\n";
        switch (ctls_Event){
            case 0x01:
                info += "LED Event "+ctlsEventData+"\r\n";
                switch (ctlsEventData){
                    case 0x00:
                        info += "LED0 OFF";
                        break;
                    case 0x10:
                        info += "LED1 OFF";
                        break;
                    case 0x20:
                        info += "LED2 OFF";
                        break;
                    case 0x30:
                        info += "LED3 OFF";
                        break;
                    case (byte)0xF0:
                        info += "ALL OFF";
                        break;
                    case 0x01:
                        info += "LED0 ON";
                        break;
                    case 0x11:
                        info += "LED1 ON";
                        break;
                    case 0x21:
                        info += "LED2 ON";
                        break;
                    case 0x31:
                        info += "LED3 ON";
                        break;
                    case (byte)0xF1:
                        info += "ALL ON";
                        break;
                }
                break;
            case 0x02:
                info += "Buzzer Event "+ctlsEventData+"\r\n";
                switch (ctlsEventData){
                    case 0x10:
                        info += "Short Beep No Change";
                        break;
                    case 0x11:
                        info += "Short Beep No Change";
                        break;
                    case 0x12:
                        info += "Double Short Beep";
                        break;
                    case 0x13:
                        info += "Triple Short Beep";
                        break;
                    case 0x20:
                        info += "200ms Beep";
                        break;
                    case 0x21:
                        info += "400ms Beep";
                        break;
                    case 0x22:
                        info += "600ms Beep";
                        break;
                }
                break;
            case 0x03:
            {
                StringBuilder line1 = new StringBuilder();
                StringBuilder line2 = new StringBuilder();
                info += "LCD Event "+ctlsEventData+"\r\n";
                ResDataStruct resData = new ResDataStruct();
                int ret = device.ctls_retrieveTerminalData(resData);
                byte language = 0x00;

                if (ret == ErrorCode.SUCCESS && resData.resData != null && resData.resData.length > 0)
                {
                    String config = Common.getHexStringFromBytes(resData.resData);
                    int idx = config.indexOf("FFFB01");
                    if (idx != -1)
                    {
                        idx += 7;
                        char c = config.charAt(idx);
                        switch(c){
                            case '1':
                                language = 0x01;
                                break;
                            case '2':
                                language = 0x02;
                                break;
                            case '3':
                                language = 0x03;
                                break;
                            case '4':
                                language = 0x04;
                                break;
                            case '5':
                                language = 0x05;
                                break;
                        }
                    }
                }
                Utility.retrieveCTLSMessage(ctlsScheme, language, ctlsEventData, line1, line2);
                info += line1.toString()+"\r\n";
                info += line2.toString();
            }
            break;

        }
        handler.post(doUpdateStatus);
    }

    @Override
    public void emvTransactionData(IDTEMVData emvData) {
        if (emvData == null) return;
        detail += Common.emvErrorCodes(emvData.result);
        detail += "\r\n";
        if (emvData.result == IDTEMVData.START_TRANS_SUCCESS)
            detail += "Start transaction response:\r\n";
        else if (emvData.result == IDTEMVData.GO_ONLINE)
            detail += "\r\nAuthentication response:\r\n";
        else
            detail += "\r\nComplete Transaction response:\r\n";
        if (emvData.unencryptedTags != null && !emvData.unencryptedTags.isEmpty())
        {
            detail += "Unencrypted Tags:\r\n";
            Set<String> keys = emvData.unencryptedTags.keySet();
            for(String key: keys){
                detail += key + ": ";
                byte[] data = emvData.unencryptedTags.get(key);
                detail += Common.getHexStringFromBytes(data) + "\r\n";
            }
        }
        if (emvData.maskedTags != null && !emvData.maskedTags.isEmpty())
        {
            detail += "Masked Tags:\r\n";
            Set<String> keys = emvData.maskedTags.keySet();
            for(String key: keys){
                detail += key + ": ";
                byte[] data = emvData.maskedTags.get(key);
                detail += Common.getHexStringFromBytes(data) + "\r\n";
            }
        }
        if (emvData.encryptedTags != null && !emvData.encryptedTags.isEmpty())
        {
            detail += "Encrypted Tags:\r\n";
            Set<String> keys = emvData.encryptedTags.keySet();
            for(String key: keys){
                detail += key + ": ";
                byte[] data = emvData.encryptedTags.get(key);
                detail += Common.getHexStringFromBytes(data) + "\r\n";
            }
        }
        handler.post(doUpdateStatus);

    }

    @Override
    public void deviceConnected() {
        isReaderConnected = true;
        handler.post(doUpdateLabel);
    }

    @Override
    public void deviceDisconnected() {
        isReaderConnected = false;
        handler.post(doUpdateLabel);
    }

    @Override
    public void timeout(int i) {
        info = "Timeout Callback Error Code: " + i;
        handler.post(doUpdateStatus);
    }

    @Override
    public void autoConfigCompleted(StructConfigParameters structConfigParameters) {

    }

    @Override
    public void autoConfigProgress(int i) {

    }

    @Override
    public void msgRKICompleted(String s) {

    }

    @Override
    public void ICCNotifyInfo(byte[] bytes, String s) {

    }

    @Override
    public void msgBatteryLow() {

    }

    @Override
    public void LoadXMLConfigFailureInfo(int i, String s) {

    }

    @Override
    public void msgToConnectDevice() {

    }

    @Override
    public void msgAudioVolumeAjustFailed() {

    }

    @Override
    public void dataInOutMonitor(byte[] bytes, boolean b) {

    }


    @Override
    public void WorldPayCallback(String xmlResponse, int resultCode, int emvCode) {
        //While you must implement both WorldPayCallback or WPCallback,
        //only execute one callback, not both.  In this example, we are not adding
        //any executable code to WorldPayCallback, and instead putting the code in
        //WPCallback below

        /*
        info += "WorldPay Callback\n";
        info += "Status Result Code: "+ WorldPay.getErrorString(resultCode)+"\n";
        info += "Status EMV Code: "+ String.valueOf(emvCode)+"\n";
        info += xmlResponse;

        detail = "";
        handler.post(doUpdateStatus);
        */

        info = "WorldPayCallback\n";
        handler.post(doUpdateStatus);
    }

    @Override
    public void WPCallback(String xmlResponse, int resultCode, int emvCode, IDTEMVData idtemvData, WorldPay.ReceiptData receiptData) {
        UMLog.i("WPCallback", "resultCode = " + resultCode);
        info += "WorldPay Callback\n";
        info += "Status Result Code: "+ WorldPay.getErrorString(resultCode)+"\n";
        info += "Status EMV Code: "+ String.valueOf(emvCode)+"\n";
        info += xmlResponse;
        if (receiptData != null){
            info += "\n\n";
            info += getReceipt(receiptData);
        }

        detail = "";
        if (resultCode == ErrorCode.RETURN_CODE_NEO_VAS_TRANSACTION) {
            if (idtemvData != null && idtemvData.msr_cardData != null && idtemvData.msr_cardData.cardData != null && idtemvData.msr_cardData.cardData.length > 0)
                detail += Common.getHexStringFromBytes(idtemvData.msr_cardData.cardData);
        }
        handler.post(doUpdateStatus);
        
        int start = xmlResponse.indexOf("<TransactionID>");
        int end = xmlResponse.indexOf("</TransactionID>");
        if (start == -1 || end == -1) {
            transactionID = "";
        } else {
            transactionID = xmlResponse.substring(start + 15, end);
        }

    }

    @Override
    public void pinpadData(byte[] bytes) {

    }

    private String printCenter(String str)
    {
        if (str == null) str = "";
        int len = str.length();
        if (len > 30)
        {
            return str;
        }
        for (int x = 0; x < (32 - len) / 2; x++)
        {
            str = " " + str;
        }
        return str;
    }


    private String printJustified(String str, String str2)
    {
        if (str == null) str = "";
        if (str2 == null) str2 = "";
        int len = str.length() + str2.length();
        if (len > 31)
        {
            return str + str2;
        }
        for (int x = len; x < 32; x++)
        {
            str2 = " " + str2;
        }
        return str + str2;
    }

    public String getReceipt(WorldPay.ReceiptData receipt)
    {
        String rec = "";
        boolean showEntryMethod = false;
        rec = rec + "================================";
        rec = rec + printCenter("\r\n");
        rec = rec + printCenter("RECEIPT");
        rec = rec + printCenter("\r\n");

        rec = rec + "================================";
        rec = rec + printCenter("\r\n");
        DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String dateString = dateFormat.format(receipt.dateTime);

        rec = rec + printCenter("Joe's Resaturant");
        rec = rec + printCenter("\r\n");

        rec = rec + printCenter("10721 Walker Street");
        rec = rec + printCenter("\r\n");
        rec = rec + printCenter("Cypress, CA 90630");
        rec = rec + printCenter("\r\n");
        rec = rec + printCenter("714-761-8886");
        rec = rec + printCenter("\r\n");
        rec = rec + printCenter("www.joesrestaurant.net");
        rec = rec + printCenter("\r\n");



        rec = rec + "--------------------------------";
        rec = rec + "\r\n";
        switch (receipt.saleType.ordinal())
        {
            case 0:
                rec = rec + printCenter("SALE");
                showEntryMethod = true;
                break;
            case 1:
                rec = rec + printCenter("PRE-AUTH");
                showEntryMethod = true;
                break;
            case 2:
                rec = rec + printCenter("COMPLETION");
                break;
            case 3:
                rec = rec + printCenter("VOID");
                break;
            case 4:
                rec = rec + printCenter("RETURN");
                break;
            case 5:
                rec = rec + printCenter("CREDIT");
                showEntryMethod = true;
                break;
            case 6:
                showEntryMethod = true;
                break;
            case 8:
                rec = rec + printCenter("REVERSAL FULL");
                break;
            case 9:
                rec = rec + printCenter("REVERSAL PARTIAL");
                break;
            default:
                break;
        }
        rec = rec + "\r\n";
        if (!receipt.isApproved)
        {
            rec = rec + printCenter("TRANSACTION FAILED");
        }
        else
        {
            rec = rec + printCenter("TRANSACTION SUCCESSFUL");
        }
        rec = rec + "\r\n";
        rec = rec + printCenter(receipt.result);

        rec = rec + "\r\n";

        if (showEntryMethod) {
            if (receipt.entryMethod == WorldPay.ENTRY_METHOD.ENTRY_METHOD_SWIPE)
                rec = rec + printJustified("Entry Method: ", "SWIPE");
            if (receipt.entryMethod == WorldPay.ENTRY_METHOD.ENTRY_METHOD_CTLS)
                rec = rec + printJustified("Entry Method: ", "CTLS");
            if (receipt.entryMethod == WorldPay.ENTRY_METHOD.ENTRY_METHOD_CONTACT)
                rec = rec + printJustified("Entry Method: ", "CONTACT");
        }

        rec = rec + "\r\n";
        rec = rec + "--------------------------------";
        rec = rec + "\r\n";
        if (receipt.card != null && receipt.card.length() > 0)
        {
            rec = rec + printJustified("Card:", receipt.card) + "\r\n";
        }
        if (receipt.account != null && receipt.account.length() > 0)
        {
            rec = rec + printJustified("Account:", receipt.account) + "\r\n";
        }

        if (receipt.transType != null && receipt.transType.length() > 0) {
            rec = rec + printJustified("Transaction Type:", receipt.transType);
            rec = rec + "\r\n";
        }
        rec = rec + printJustified("Date/Time:", dateString);

        rec = rec + "\r\n";

        if (receipt.amount != null && receipt.amount.length() > 0) {
            rec = rec + printJustified("Amount:", receipt.amount);
            rec = rec + "\r\n";
        }
        if (receipt.iad != null && receipt.iad.length() > 0)
        {
            rec = rec + printJustified("IAD:", receipt.iad);
            rec = rec + "\r\n";
        }
        if (receipt.aid != null && receipt.aid.length() > 0)
        {
            rec = rec + printJustified("AID:", receipt.aid);
            rec = rec + "\r\n";
        }
        if (receipt.authCode != null && receipt.authCode.length() > 0)
        {
            rec = rec + printJustified("AUTH:", receipt.authCode);
            rec = rec + "\r\n";
        }
        if (receipt.transID != null && receipt.transID.length() > 0)
        {
            rec = rec + printJustified("TRANS ID:", receipt.transID);
            rec = rec + "\r\n";
        }
        if (receipt.cert != null && receipt.cert.length() > 0)
        {
            rec = rec + printJustified("TC:", receipt.cert);
            rec = rec + "\r\n";
        }

        if (receipt.cvm == WorldPay.CVM_TYPE.CVM_TYPE_NO_CVM)
        {
            rec = rec + "\r\n\r\nNO CVM\r\n\r\n";

        }
        if (receipt.cvm == WorldPay.CVM_TYPE.CVM_TYPE_SIGNATURE)
        {
                rec = rec + "Card Holder Signature:\r\n\r\n\r\n\r\n------------------------------\r\n" + receipt.name + "\r\n\r\nI Acknowledge Satisfactory Rec-\r\n";
                rec = rec + "eipt Of Relative Goods/Services\r\n\r\n";
        }

        rec = rec + "\r\n\r\n";
        return rec;

    }

}